=== debian/changelog ===
metview (5.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 25 May 2018 11:41:28 +0100

metview (5.0.1-3) unstable; urgency=medium

  * Standards-Version: 4.1.4
  * Use gfortran-8 to o compile wih new mod files. Closes: #897809

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 09 May 2018 08:39:47 +0100
